/* GCC */
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <deque>

using namespace std;

struct road
{
    int a, b, p;
    road(int _a, int _b, int _p)
    {
        a = _a;
        b = _b;
        p = _p;
    }
    road()
    {
        a = 0;
        b = 0;
        p = 0;
    }
};

bool roadsorter(road a, road b)
{
    return a.p > b.p;
}

int main()
{
    fstream fs;
    int cit, roa;
    fs.open("roads.in", fstream::in);
    fs >> cit >> roa;
    deque<road> Roads(roa);
    deque<int> Roadcount(roa);
    for(int i = 0; i < roa; i++)
    {
        Roadcount.push_back(i+1);
    }
    int Matrix[cit][cit];
    for(int i = 0; i < cit; i++)
        for(int j = 0; j < cit; j++)
            Matrix[i][j] = -1;
    for(int i = 0; i < roa; i++)
    {
        road t = road(0, 0, 0);
        fs >> t.a;
        fs >> t.b;
        fs >> t.p;
        Matrix[t.a-1][t.b-1] = t.p;
        Matrix[t.b-1][t.a-1] = t.p;
        Roads[i] = t;
    }
    fs.close();
    fs.open("roads.out", fstream::out);
    //Matrix is ready
    sort(Roads.begin(), Roads.end(), roadsorter);
    int DijkstraMatrix[cit];
    //from the most expensive
    bool candelete = false;
    //for each road
    for(int i = 0; i < Roads.size(); i++)
    {
        if(candelete)
        {
            i = 0;
            Roads.pop_front();
        Roadcount.pop_front();
            candelete = false;
        }
        for(int k = 0; k < roa; k++)
            DijkstraMatrix[k] = -1;

        Matrix[Roads[i].a-1][Roads[i].b-1] = -1;
        Matrix[Roads[i].b-1][Roads[i].a-1] = -1;
        for(int i1 = 0; i1 < cit; i1++)
        {
            for(int i2 = 0; i2 < cit; i2++)
                cout << Matrix[i1][i2] << ' ';
            cout << endl;
        }
        DijkstraMatrix[Roads[i].a-1] = 0;
        //initial vals
        for(int j = 0; j < cit; j++)
            if(j != Roads[i].a-1)
                if(Matrix[Roads[i].a-1][j] != -1)
                    DijkstraMatrix[j] = Matrix[Roads[i].a-1][j];

        for(int row = 0; row < roa-1; row++)
        {
            for(int r = 0; r < cit; r++)
                        cout << DijkstraMatrix[r] << ' ';
                    cout << endl;
            cout << endl;
            for(int iter = 0; iter < cit; iter++)
            {
                for(int c = 0; c < cit; c++)
                {
                    if(!(iter == c || DijkstraMatrix[iter] == -1))
                        if(Matrix[iter][c] != -1 && ((Matrix[iter][c] + DijkstraMatrix[iter] < DijkstraMatrix[c]) || (DijkstraMatrix[c] == -1)))
                            DijkstraMatrix[c] = Matrix[iter][c] + DijkstraMatrix[iter];


                }
            }
            for(int r = 0; r < cit; r++)
                        cout << DijkstraMatrix[r] << ' ';
                    cout << endl;
            if(DijkstraMatrix[Roads[i].b-1] != -1)
            {
                candelete = true;
            }
            else
            {
                Matrix[Roads[i].a][Roads[i].b-1] = Roads[i].p;
                Matrix[Roads[i].b][Roads[i].a-1] = Roads[i].p;
            }
        }
    }
    if(candelete)
    {
        Roads.pop_front();
        Roadcount.pop_front();
    }
    for(int i = 0; i < Roadcount.size(); i++)
        fs << Roadcount[i];
    return 0;

}
