/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <set>
#include <vector>
#define N 4096

using namespace std;

int n; // cities
int m; // roads

struct road {
    int from;
    int to;
    int gold;

    int id;
};

vector<road> roads;
vector<int> mst;
set<int> v;

bool byGold(const road &x, const road &y) {
    return x.gold < y.gold;
}

bool lookup(int x) {
    return (v.find(x) != v.end());
}

void add(const road &r) {
    v.insert(r.from);
    v.insert(r.to);
    mst.push_back(r.id);
}

void solve() {
    // aid: roads | sort byGold
    sort(roads.begin(), roads.end(), byGold);

    v.clear();

    add(roads[0]);
    int padding = 1;

    while (v.size() < n) {
        for (int i = padding; i < m; i++) {
            const road &r = roads[i];

            bool startIn = lookup(r.from);
            bool endIn = lookup(r.to);

            if (startIn xor endIn) {
                add(r);
            }
        }
    }
}

int main() {
    freopen("roads.in", "r", stdin);
    freopen("roads.out", "w", stdout);

    scanf("%d %d\n", &n, &m);
    roads.reserve(m);
    for (int u = 1; u <= m; u++) {
        road r;
        r.id = u;

        scanf("%d %d %d\n",
              &r.from, &r.to, &r.gold);

        roads.push_back(r);
    }

    solve();

    if (mst.size() > 0) {
        printf("%d", mst[0]);
    }

    for (int i = 1; i < mst.size(); i++) {
        printf(" %d", mst[i]);
    }

    printf("\n");

    return 0;
}
