/* GCC */
#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

const int NMAX = 5000;
const int MMAX = 10000000;

int n, m;
struct edge
{
    int v, to, w, id;
};
edge g[NMAX];
int dsu[NMAX], ans[NMAX], sz = 0;

bool cmp(edge a, edge b)
{
    return a.w < b.w;
}

int get(int v)
{
    return (v == dsu[v] ? v : dsu[v] = get(dsu[v]));
}

int main()
{
    ios_base::sync_with_stdio(0);
    freopen("roads.in", "r", stdin);
    freopen("roads.out", "w", stdout);
    scanf("%d %d", &n, &m);
    int x, y, w;
    for (int i = 1; i <= n; ++i)
    {
        scanf("%d %d %d", &x, &y, &w);
        g[i].v = x;
        g[i].to = y;
        g[i].w = w;
        g[i].id = i;
    }
    sort(g + 1, g + m + 1, cmp);
    for (int i = 1; i <= n; ++i)
        dsu[i] = i;
    srand(482932);
    for (int i = 1; i <= m; ++i)
    {
        edge cur = g[i];
        int v = cur.v, to = cur.to;
        v = get(v), to = get(to);
        if (v != to)
        {
            ans[++sz] = cur.id;
            if (rand() % 2)
                swap(v, to);
            dsu[v] = to;
        }
    }
    for (int i = 1; i < sz; ++i)
        printf("%d ", ans[i]);
    printf("%d\n", ans[sz]);
    return 0;
}
